function! s:getGruvColor(group)
  let guiColor = synIDattr(hlID(a:group), "fg", "gui")
  let termColor = synIDattr(hlID(a:group), "fg", "cterm")
  return [ guiColor, termColor ]
endfunction

if exists('g:lightline')
  let s:bg0    = s:getGruvColor('GruvboxBg0')
  let s:bg1    = s:getGruvColor('GruvboxBg1')
  let s:bg2    = s:getGruvColor('GruvboxBg2')
  let s:bg3    = s:getGruvColor('GruvboxBg3')
  let s:bg4    = s:getGruvColor('GruvboxBg4')
  let s:fg0    = s:getGruvColor('GruvboxFg0')
  let s:fg1    = s:getGruvColor('GruvboxFg1')
  let s:fg2    = s:getGruvColor('GruvboxFg2')
  let s:fg3    = s:getGruvColor('GruvboxFg3')
  let s:fg4    = s:getGruvColor('GruvboxFg4')

  let s:red    = s:getGruvColor('GruvboxRed')
  let s:green  = s:getGruvColor('GruvboxGreen')
  let s:yellow = s:getGruvColor('GruvboxYellow')
  let s:blue   = s:getGruvColor('GruvboxBlue')
  let s:purple = s:getGruvColor('GruvboxPurple')
  let s:aqua   = s:getGruvColor('GruvboxAqua')
  let s:orange = s:getGruvColor('GruvboxOrange')

  let s:p = {'normal': {}, 'inactive': {}, 'insert': {}, 'replace': {}, 'visual': {}, 'tabline': {}, 'terminal': {}}

  let s:p.normal.left     = [ [ s:bg0, s:fg2, 'bold' ], [ s:fg1, s:bg2 ] ]
  let s:p.normal.right    = [ [ s:bg0, s:fg2 ], [ s:fg2, s:bg2 ] ]
  let s:p.normal.middle   = [ [ s:fg2, s:bg1 ] ]

  let s:p.inactive.left   = [ [ s:bg4, s:bg1 ] ]
  let s:p.inactive.right  = [ [ s:bg4, s:bg1 ] ]
  let s:p.inactive.middle = [ [ s:bg4, s:bg1 ] ]

  let s:p.insert.left     = [ [ s:bg0, s:green, 'bold' ], [ s:fg1, s:bg2 ] ]
  let s:p.insert.right    = copy(s:p.normal.right)
  let s:p.insert.middle   = copy(s:p.normal.middle)

  let s:p.terminal.left   = [ [ s:bg0, s:blue, 'bold' ], [ s:fg1, s:bg2 ] ]
  let s:p.terminal.right  = copy(s:p.normal.right)
  let s:p.terminal.middle = copy(s:p.normal.middle)

  let s:p.replace.left    = [ [ s:bg0, s:orange, 'bold' ], [ s:fg1, s:bg2 ] ]
  let s:p.replace.right   = copy(s:p.normal.right)
  let s:p.replace.middle  = copy(s:p.normal.middle)

  let s:p.visual.left     = [ [ s:bg0, s:yellow, 'bold' ], [ s:fg1, s:bg2 ] ]
  let s:p.visual.right    = copy(s:p.normal.right)
  let s:p.visual.middle   = copy(s:p.normal.middle)

  let s:p.tabline.left    = [ [ s:bg4, s:bg1 ] ]
  let s:p.tabline.tabsel  = [ [ s:green, s:bg1 ] ]
  let s:p.tabline.middle  = [ [ s:bg1, s:bg1 ] ]
  let s:p.tabline.right   = [ [ s:bg0, s:orange ] ]

  let s:p.normal.error    = [ [ s:bg0, s:orange ] ]
  let s:p.normal.warning  = [ [ s:bg2, s:yellow ] ]

  let g:lightline#colorscheme#gruvboxlike#palette = lightline#colorscheme#flatten(s:p)
endif
